use tonic::transport;

use lws_vfs::LwsVfsIns;
use lws_vfs::lws_vfs::lws_vfs_server::LwsVfsServer;

// fn main() {
//     println!("Hello, world!");
//     let file = "test.txt";
//     let mut sta = Stat {
//         st_size: 0,
//         st_mode: 0,
//     };
//     let mut fi = FuseFileInfo {};
//     getattr(file, &mut sta, &mut fi);
// }

#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
    let instance = match LwsVfsIns::new("config.json"){
        Ok(greeter) => greeter,
        Err(e) => {
            println!("Error creating lws server instance: {:?}", e);
            return Err(e);
        }
    };
    let addr = format!("[::1]:{}", instance.config.get_port());
    println!("Listening on {}", addr);
    transport::Server::builder()
        .add_service(LwsVfsServer::new(instance))
        .serve(addr.parse()?)
        .await?;
    Ok(())
}
